;-----------------------------------------------------
;
; HSP3Dishp W[umod_dstr.asv
;
; Ver 1.0 (ӁFuhsp3dish.asvK{łBOɁuhsp3dish.asvCN[hĂ)
;
; By. ܂˂
;
; https://sites.google.com/site/simakuroneko/
;
; simakuroneko@gmail.com
;
;-----------------------------------------------------
#ifndef __MOD_DSTR__
#define __MOD_DSTR__


;-----------------------------------------------------
#module mod_dstr

#define	FONT_INI_FILE		"mod_dstr.ini"

#const	FONT_CODE_MAX		65535

#const	SPRIT_MAX			99999
#const  SPRIT_CUT_LENGTH	1024

#const	FALSE				0
#const	TRUE				1

;-----------------------------------------------------
#deffunc dstr_init

	waring_flg		= FALSE
	ini_waring_mes	= ""

	plat_form = PLATFORM_WINDOWS
	getreq plat_form, SYSREQ_PLATFORM

	switch plat_form
	case PLATFORM_WINDOWS
		exist FONT_INI_FILE
		if strsize == -1 {
			waring_flg			= TRUE
			ini_waring_mes(0)	= FONT_INI_FILE + " DPMt@CɊ܂܂ĂȂA"
			ini_waring_mes(1)	= "JgtH_ɓĂ܂B"
			ini_waring_mes(2)	= ""
			ini_waring_mes(3)	= ""
		}
		swbreak
	case PLATFORM_IOS
	case PLATFORM_ANDROID
	default
		exist FONT_INI_FILE
		if strsize == -1 {
			waring_flg			= TRUE
			ini_waring_mes(0)	= FONT_INI_FILE + " DPMt@CɊ܂܂ĂȂA"
			ini_waring_mes(1)	= "vWFNgtH_[assets]tH_ɓĂ܂B"
			ini_waring_mes(2)	= "DPMt@CɊ܂܂ẴbZ[W\ꍇ́A
			ini_waring_mes(3)	= "vWFNgtH_[assets]tH_ɓĂB"
		}
		swbreak
	swend

	if waring_flg {
		key = 0
		font "", 10
		repeat
			redraw 0
			color 0, 0, 0
			boxf
			color 255, 255, 255
			pos 0, 0	: mes ini_waring_mes(0) : mes ini_waring_mes(1) : mes ini_waring_mes(2) : mes ini_waring_mes(3)
			pos 0, 128	: mes "^bvƃvOI܂B"
			redraw 1
			stick key
			if key && 256 : end
			await 16
		loop
	}

	dim f_cd, FONT_CODE_MAX

	bload FONT_INI_FILE, f_cd

	return



;-----------------------------------------------------
; dstr_utf8
;
; SJIS̕UTF-8̕ɕϊ܂
;
;
; buff         : ϊSJIS̕
;
;
;=====================================================
; SAMPLE
;
;	#include "hsp3dish.as"
;	#include "mod_picmes.as"
;	#include "mod_dstr.as"
;
;
;	picmes_init						; mod_picmes̏
;	dstr_init						; mod_dstȑ
;
;	exist "test.txt"				; (SJISŕۑĂeLXgt@C)
;	size = strsize					; t@C̃TCY擾
;
;	sdim buff, size
;	bload "test.txt", buff, size
;
;	buff = dstr_utf8(buff)			; SJISUTF-8ɕϊ
;
;	dstr_rep buff, "\n", ""			; s[\n]폜
;
;	redraw 0
;	color 0, 0, 0 : boxf
;
;	pos 0, 0
;
;	picmes "t@Ce(s͍폜)='" + buff + "'"
;	picmes "                  = " + str(dstr_len(buff))
;	picmes "TڂR      ='" + dstr_mid(buff, 4, 3) + "'"
;
;	redraw 1
;
;-----------------------------------------------------
#defcfunc dstr_utf8 str buff

	sdim in_buff, strlen(buff)
	sdim cut_buff, 4
	dim cut_byte,  3

	c_index			= 0
	c_byte			= 0
	c_cd			= 0
	cut_buff		= ""
	get_hex			= ""
	get_utf8_hex	= ""
	cut_hex			= ""
	hex_len			= 0
	in_buff			= buff
	len_buff		= strlen(in_buff)
	join_buff		= ""
	c				= 0
	i				= 0


	switch plat_form
	case PLATFORM_WINDOWS
		join_buff = in_buff
		swbreak

	case PLATFORM_IOS
	case PLATFORM_ANDROID
	default
		repeat len_buff

			if c_index >= len_buff : break

			etc_ascii	= 0
			c_byte		= 0
			get_hex		= ""
			cut_buff	= ""
			cd_point	= 0
			c_cd		= peek(in_buff, c_index)
			b_cnt		= 0

			if c_cd <= 31 {
				c_byte = 1
				etc_ascii = 1
			} else {
				if c_cd <= 127 {
					c_byte = 1
				} else {
					if c_cd >= 253 {
						c_byte = 1
					} else {
						if c_cd >= 224 {
							if c_cd <= 252 : c_byte = 2
						} else {
							if c_cd >= 161 {
								if c_cd <= 223 : c_byte = 1
							} else {
								if c_cd >= 129 : c_byte = 2
							}
						}
					}
				}
			}

			cut_buff = strmid(in_buff, c_index, c_byte)

			if etc_ascii == 0 {

				repeat c_byte
					cut_byte(cnt) = peek(cut_buff, cnt)
				loop

				switch c_byte
				case 1 : get_hex = strf("%x", cut_byte(0))					: swbreak
				case 2 : get_hex = strf("%x%x", cut_byte(0), cut_byte(1))	: swbreak
				swend

				cut_hex			= ""
				cd_point		= int("$" + get_hex)
				long_point		= f_cd(cd_point)

				dim b_byte, 3
				b_1				= (long_point / 256 / 256 ) \ 256
				b_2				= (long_point / 256 ) \ 256
				b_3				= long_point \ 256

				if b_1 > 0 {
					b_byte(b_cnt) = b_1
					b_cnt++
				}
				if b_2 > 0 {
					b_byte(b_cnt) = b_2
					b_cnt++
				}
				if b_3 > 0 {
					b_byte(b_cnt) = b_3
					b_cnt++
				}

				sdim one_buff, b_cnt
				one_buff = ""

				repeat b_cnt
					poke one_buff, cnt, b_byte(cnt)
				loop

			} else {

				sdim one_buff, strlen(cut_buff)
				one_buff = cut_buff

			}

			join_buff	+= one_buff
			c_index		+= c_byte

		loop
		swbreak
	swend

	in_buff = ""
	sdim in_buff, 1

	return join_buff


;-----------------------------------------------------
#defcfunc dstr_instr str z_buff, int ind, str serach_buff

	getreq plat_form, SYSREQ_PLATFORM

	r = -1
	c_buff = ""

	s = dstr_len(serach_buff)
	i = dstr_len(z_buff) - s + 1

	sdim in_buff, strlen(z_buff)

	g_length	= s
	c_cd		= 0
	in_buff		= z_buff
	len_buff	= strlen(in_buff)

	repeat i

		s_index = cnt + ind
		count_index	= 0
		set_index	= 0
		plus_index	= 0
		index_flg	= FALSE
		get_index	= 0

		sdim re_buff, 3, g_length

		repeat len_buff

			if set_index >= len_buff : break

			c_cd = peek(in_buff, set_index)

			switch plat_form
			case PLATFORM_WINDOWS

				if c_cd <= 127 {
					plus_index = 1
				} else {
					if c_cd >= 253 {
						plus_index = 1
					} else {
						if c_cd >= 224 {
							if c_cd <= 252 : plus_index = 2
						} else {
							if c_cd >= 161 {
								if c_cd <= 223 : plus_index = 1
							} else {
								if c_cd >= 129 : plus_index = 2
							}
						}
					}
				}

				swbreak

			case PLATFORM_IOS
			case PLATFORM_ANDROID
			default

				if c_cd <= 127 {
					plus_index = 1
				} else {
					if c_cd >= 224 {
						if c_cd <= 239 : plus_index = 3
					} else {
						if c_cd >= 192 {
							if c_cd <= 223 : plus_index = 2
						}
					}
				}

				swbreak
				
			swend

			if cnt >= s_index {
				if get_index < g_length {
					index_flg = TRUE
				} else {
					break
				}
				get_index++
			}

			if index_flg {
				re_buff(count_index) = strmid(in_buff, set_index, plus_index)
				count_index++
			}

			set_index += plus_index

		loop

		join_buff	= ""
		loop_length	= g_length

		if loop_length > count_index : loop_length = count_index

		repeat loop_length
			join_buff += re_buff(cnt)
		loop

		if join_buff == serach_buff {
			r = cnt
			break
		}
	loop

	in_buff = ""
	sdim in_buff, 1
	sdim re_buff, 1, 1


	return r


;-----------------------------------------------------
; dstr_mid
;
; ̈ꕔo(oCgPʂł͂ȂAŎo܂)
;
;
; buff         : oƂ̕񂪊i[Ăϐ
; start_index  : on߂̃CfbNX(Jnʒu0)
; get_length   : o
;
;
;=====================================================
; SAMPLE
;
;	moji_A = "AIU"
;   moji_B = dstr_mid(moji_A, 3, 2)
;   pos 0, 0 : picmes moji_B   ;""
;
;-----------------------------------------------------
#defcfunc dstr_mid str buff, int start_index, int get_length

	getreq plat_form, SYSREQ_PLATFORM

	sdim in_buff, strlen(buff)

	c_cd		= 0
	count_index	= 0
	set_index	= 0
	plus_index	= 0
	index_flg	= FALSE
	get_index	= 0
	in_buff		= buff
	len_buff	= strlen(in_buff)

	if start_index == -1 {
		sdim re_buff, 3, len_buff
	} else {
		sdim re_buff, 3, get_length
	}

	repeat len_buff

		if set_index >= len_buff : break

		c_cd = peek(in_buff, set_index)

		switch plat_form
		case PLATFORM_WINDOWS

			if c_cd <= 127 {
				plus_index = 1
			} else {
				if c_cd >= 253 {
					plus_index = 1
				} else {
					if c_cd >= 224 {
						if c_cd <= 252 : plus_index = 2
					} else {
						if c_cd >= 161 {
							if c_cd <= 223 : plus_index = 1
						} else {
							if c_cd >= 129 : plus_index = 2
						}
					}
				}
			}

			swbreak

		case PLATFORM_IOS
		case PLATFORM_ANDROID
		default

			if c_cd <= 127 {
				plus_index = 1
			} else {
				if c_cd >= 224 {
					if c_cd <= 239 : plus_index = 3
				} else {
					if c_cd >= 192 {
						if c_cd <= 223 : plus_index = 2
					}
				}
			}

			swbreak
			
		swend

		if start_index == -1 {
			index_flg = TRUE
		} else {
			if cnt >= start_index {
				if get_index < get_length {
					index_flg = TRUE
				} else {
					break
				}
				get_index++
			}
		}

		if index_flg {
			re_buff(count_index) = strmid(in_buff, set_index, plus_index)
			count_index++
		}

		set_index += plus_index

	loop

	join_buff	= ""
	loop_length	= get_length

	if loop_length > count_index : loop_length = count_index

	switch start_index
	case -1
		repeat loop_length
			c			= count_index - loop_length + cnt
			join_buff	+= re_buff(c)
		loop
		swbreak
	default
		repeat loop_length
			join_buff += re_buff(cnt)
		loop
		swbreak
	swend

	in_buff = ""
	sdim in_buff, 1
	sdim re_buff, 1, 1

	return join_buff


;-----------------------------------------------------
; dstr_len
;
; ̒𒲂ׂ(oCgPʂł͂ȂAŒׂ܂)
;
;
; buff         : ̒𒲂ׂ^̕ϐ
;
;
;=====================================================
; SAMPLE
;
;	moji = "AIU"
;   c = dstr_len(moji)
;   pos 0, 0 : picmes c   ;:5
;
;-----------------------------------------------------
#defcfunc dstr_len str buff

	getreq plat_form, SYSREQ_PLATFORM

	sdim in_buff, strlen(buff)

	c_cd			= 0
	count_index		= 0
	set_index		= 0
	in_buff			= buff
	len_buff		= strlen(in_buff)

	repeat len_buff

		if set_index >= len_buff : break

		c_cd = peek(in_buff, set_index)

		switch plat_form
		case PLATFORM_WINDOWS

			if c_cd <= 127 {
				plus_index = 1
			} else {
				if c_cd >= 253 {
					plus_index = 1
				} else {
					if c_cd >= 224 {
						if c_cd <= 252 : plus_index = 2
					} else {
						if c_cd >= 161 {
							if c_cd <= 223 : plus_index = 1
						} else {
							if c_cd >= 129 : plus_index = 2
						}
					}
				}
			}

			swbreak

		case PLATFORM_IOS
		case PLATFORM_ANDROID
		default

			if c_cd <= 127 {
				plus_index = 1
			} else {
				if c_cd >= 224 {
					if c_cd <= 239 : plus_index = 3
				} else {
					if c_cd >= 192 {
						if c_cd <= 223 : plus_index = 2
					}
				}
			}

			swbreak

		swend

		count_index++
		set_index += plus_index

	loop

	in_buff = ""
	sdim in_buff, 1

	return count_index


;-----------------------------------------------------
; dstr_split
;
; ̕
;
;
; buff         : ̕񂪑ꂽϐ
; dem          : ؂p
; gs           : ꂽvfϐ
;
;
; ߂l(stat) : ꂽ
;
;=====================================================
; SAMPLE
;
;	moji = "123-456-789"
;   spt  = ""
;   dstr_split moji, "-", spt
;
;   repeat stat
;        picmes spt(cnt)   ; : "123"
;                          ;       "456"
;                          ;       "789"
;   loop
;
;-----------------------------------------------------
#deffunc dstr_split str buff, str dem, array re

	dim strpos,		SPRIT_MAX
	dim strleng,	SPRIT_MAX

	in_buff		= buff
	i			= 0
	c			= 0
	y			= 0
	j			= 0
	lenms		= strlen(dem)
	re			= ""

	do
		c = instr(in_buff, y, dem)
		if c < 0 : _break
		strpos(i)	= c + lenms
		strleng(i)	= c
		y			+= strpos(i)
		i++
	until c < 0

	strleng(i) = strlen(in_buff)
	i++

	sdim re, SPRIT_CUT_LENGTH, i

	repeat i
		re(cnt)	= strmid(in_buff, j, strleng(cnt))
		j		+= strpos(cnt)
	loop


	dim strpos,		1
	dim strleng,	1

	return i


#global

;-----------------------------------------------------
#endif
